#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QDebug>
#include <QMessageBox>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    readcount = 0;
    this->setWindowTitle("生理信号加速SOC测试软件-夏鹏、李宪龙、张涛");
    //连接槽函数
    connect(&global_port,&QSerialPort::readyRead,this,&serialPort_readyRead);
    //===============================加载数据=========================
    //========================加载正常心电=======================
    QFile inFile("D://Label//Normal_100_234.csv");
    QStringList lines;
    QVector<double> TempArr;
    //打开文件
    lines.clear();
    if (inFile.open(QIODevice::ReadOnly))
    {
        QTextStream stream_text(&inFile);
        while (!stream_text.atEnd())
        {
            lines.push_back(stream_text.readLine());
        }
        qDebug() << "Read " << "Normal_100_234.csv" << lines.length() << "datas";
        //关闭文件
        inFile.close();
        //使用逗号分割
        //清空临时存储
        for(int j = 0; j < lines.size(); j++){
            QString line = lines.at(j);
            QStringList split = line.split(",");
            //将转成的浮点值存入临时数组
            TempArr.clear();
            for(int k = 0; k < split.length(); ++k){
               TempArr.append(QString(split[k]).toDouble());
            }
            //将临时数组存入类数组
            NormalArray.append(TempArr);
        }
    }
    //========================加载房性早搏心电=======================
    inFile.setFileName("D://Label//Atrial_premature_baet_100_234.csv");
    //打开文件
    lines.clear();
    if (inFile.open(QIODevice::ReadOnly))
    {
        QTextStream stream_text(&inFile);
        while (!stream_text.atEnd())
        {
            lines.push_back(stream_text.readLine());
        }
        qDebug() << "Read " << "Atrial_premature_baet_100_234.csv" << lines.length() << "datas";
        //关闭文件
        inFile.close();
        //使用逗号分割
        //清空临时存储
        for(int j = 0; j < lines.size(); j++){
            QString line = lines.at(j);
            QStringList split = line.split(",");
            //将转成的浮点值存入临时数组
            TempArr.clear();
            for(int k = 0; k < split.length(); ++k){
               TempArr.append(QString(split[k]).toDouble());
            }
            //将临时数组存入类数组
            Atrial_prematureArray.append(TempArr);
        }
    }
    //========================加载室性早搏心电=======================
    inFile.setFileName("D://Label//Premature_ventricular_contraction_100_234.csv");
    //打开文件
    lines.clear();
    if (inFile.open(QIODevice::ReadOnly))
    {
        QTextStream stream_text(&inFile);
        while (!stream_text.atEnd())
        {
            lines.push_back(stream_text.readLine());
        }
        qDebug() << "Read " << "Premature_ventricular_contraction_100_234.csv" << lines.length() << "datas";
        //关闭文件
        inFile.close();
        //使用逗号分割
        //清空临时存储
        for(int j = 0; j < lines.size(); j++){
            QString line = lines.at(j);
            QStringList split = line.split(",");
            //将转成的浮点值存入临时数组
            TempArr.clear();
            for(int k = 0; k < split.length(); ++k){
               TempArr.append(QString(split[k]).toDouble());
            }
            //将临时数组存入类数组
            Premature_ventricular_contractionArray.append(TempArr);
        }
    }
    //========================加载左阻滞心电=======================
    inFile.setFileName("D://Label//Left_bundle_branch_block_beat_100_234.csv");
    //打开文件
    lines.clear();
    if (inFile.open(QIODevice::ReadOnly))
    {
        QTextStream stream_text(&inFile);
        while (!stream_text.atEnd())
        {
            lines.push_back(stream_text.readLine());
        }
        qDebug() << "Read " << "Left_bundle_branch_block_beat_100_234.csv" << lines.length() << "datas";
        //关闭文件
        inFile.close();
        //使用逗号分割
        //清空临时存储
        for(int j = 0; j < lines.size(); j++){
            QString line = lines.at(j);
            QStringList split = line.split(",");
            //将转成的浮点值存入临时数组
            TempArr.clear();
            for(int k = 0; k < split.length(); ++k){
               TempArr.append(QString(split[k]).toDouble());
            }
            //将临时数组存入类数组
            LB_Array.append(TempArr);
        }
    }
    //========================加载右阻滞心电=======================
    inFile.setFileName("D://Label//Right_bundle_branch_block_beat_100_234.csv");
    //打开文件
    lines.clear();
    if (inFile.open(QIODevice::ReadOnly))
    {
        QTextStream stream_text(&inFile);
        while (!stream_text.atEnd())
        {
            lines.push_back(stream_text.readLine());
        }
        qDebug() << "Read " << "Right_bundle_branch_block_beat_100_234.csv" << lines.length() << "datas";
        //关闭文件
        inFile.close();
        //使用逗号分割
        //清空临时存储
        for(int j = 0; j < lines.size(); j++){
            QString line = lines.at(j);
            QStringList split = line.split(",");
            //将转成的浮点值存入临时数组
            TempArr.clear();
            for(int k = 0; k < split.length(); ++k){
               TempArr.append(QString(split[k]).toDouble());
            }
            //将临时数组存入类数组
            RB_Array.append(TempArr);
        }
    }
    //========================加载右阻滞心电=======================
    inFile.setFileName("D://Label//Ventricular_fibrillation_cu01_cu35.csv");
    //打开文件
    lines.clear();
    if (inFile.open(QIODevice::ReadOnly))
    {
        QTextStream stream_text(&inFile);
        while (!stream_text.atEnd())
        {
            lines.push_back(stream_text.readLine());
        }
        qDebug() << "Read " << "Ventricular_fibrillation_cu01_cu35.csv" << lines.length() << "datas";
        //关闭文件
        inFile.close();
        //使用逗号分割
        //清空临时存储
        for(int j = 0; j < lines.size(); j++){
            QString line = lines.at(j);
            QStringList split = line.split(",");
            //将转成的浮点值存入临时数组
            TempArr.clear();
            for(int k = 0; k < split.length(); ++k){
               TempArr.append(QString(split[k]).toDouble());
            }
            //将临时数组存入类数组
            VF_Array.append(TempArr);
        }
    }

}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButtonSend_clicked()
{
    QByteArray tx_buf;
    tx_buf.resize(505);
    unsigned int u16_value;
    //帧头
    tx_buf[0]=0xaa;
    tx_buf[1]=0x55;
    //帧识别号
    tx_buf[2]=0x00;
    //检查数据量
    if(CurLoadBuff.size() != 250){
        //报告数据错误
        QMessageBox message(QMessageBox::NoIcon, "数据错误", "当前没有加载数据！");
        message.exec();
    }
    //加入数据
    else{
        qDebug()<< CurLoadBuff;
        for(int i = 0; i < 250; i++){
            u16_value = (unsigned int)(CurLoadBuff[i] * 1000.0 + 32767.0);
            tx_buf[(i*2)+4] = (unsigned char)u16_value & 0x00ff;
            u16_value = u16_value >> 8;
            tx_buf[(i*2)+3] = (unsigned char)u16_value & 0x00ff;
        }
        //帧尾
        tx_buf[503] = 0x33;
        tx_buf[504] = 0xcc;
        //把数据通过串口发送出去
        global_port.write(tx_buf);
    }
    tx_buf.clear();
}

void MainWindow::on_pushButtonUart_clicked()
{
    if(this->ui->pushButtonUart->text()=="打开串口"){
        if(ui->textEdit->toPlainText() != ""){
            //获取串口复选框中的串口号
            global_port.setPortName(ui->textEdit->toPlainText());
            //设置波特率
            global_port.setBaudRate(QSerialPort::Baud115200);
            //设置串口数据位8
            global_port.setDataBits(QSerialPort::Data8);
            //无校验位
            global_port.setParity(QSerialPort::NoParity);
            //1位停止位
            global_port.setStopBits(QSerialPort::OneStop);
            //无流控
            global_port.setFlowControl(QSerialPort::NoFlowControl);
            //打开串口
            if(!global_port.open(QIODevice::ReadWrite))
            {
                //修改串口打开按键的内容
                QMessageBox message(QMessageBox::NoIcon, "串口打开状态", "串口打开失败！");
                message.exec();
            }
            else{
                //修改串口打开按键的内容
                this->ui->pushButtonUart->setText("关闭串口");
                QMessageBox message(QMessageBox::NoIcon, "串口打开状态", "串口打开成功！");
                message.exec();
            }
        }
        else{
            //报告没有可用串口
            QMessageBox message(QMessageBox::NoIcon, "串口打开状态", "当前没有可用串口！");
            message.exec();
        }
    }
    else{
        //报告关闭串口
        global_port.close();
        this->ui->pushButtonUart->setText("打开串口");
        QMessageBox message(QMessageBox::NoIcon, "串口关闭状态", "串口关闭！");
        message.exec();
    }
}

void MainWindow::on_pushButtonNormal_clicked()
{
    QChart* c = new QChart();
    QLineSeries* line1 = new QLineSeries();
    CurLoadBuff.clear();
    for(int i = 0; i < NormalArray[readcount].size(); ++i){
        line1->append(i,NormalArray[readcount][i]);
        CurLoadBuff.append(NormalArray[readcount][i]);
    }
    c->addSeries(line1);
    ui->widgetshow->setChart(c);
    ++readcount;
    QString str;
    str.sprintf("已经加载%d次数据。",readcount);
    ui->label_times->setText(str);
}

void MainWindow::on_pushButtonAPB_clicked()
{
    QChart* c = new QChart();
    QLineSeries* line1 = new QLineSeries();
    CurLoadBuff.clear();
    for(int i = 0; i < Atrial_prematureArray[readcount].size(); ++i){
        line1->append(i,Atrial_prematureArray[readcount][i]);
        CurLoadBuff.append(Atrial_prematureArray[readcount][i]);
    }
    c->addSeries(line1);
    ui->widgetshow->setChart(c);
    ++readcount;
    QString str;
    str.sprintf("已经加载%d次数据。",readcount);
    ui->label_times->setText(str);
}

void MainWindow::on_pushButtonPVC_clicked()
{
    QChart* c = new QChart();
    QLineSeries* line1 = new QLineSeries();
    CurLoadBuff.clear();
    for(int i = 0; i < Premature_ventricular_contractionArray[readcount].size(); ++i){
        line1->append(i,Premature_ventricular_contractionArray[readcount][i]);
        CurLoadBuff.append(Premature_ventricular_contractionArray[readcount][i]);
    }
    c->addSeries(line1);
    ui->widgetshow->setChart(c);
    ++readcount;
    QString str;
    str.sprintf("已经加载%d次数据。",readcount);
    ui->label_times->setText(str);
}

void MainWindow::on_pushButtonLeft_clicked()
{
    QChart* c = new QChart();
    QLineSeries* line1 = new QLineSeries();
    CurLoadBuff.clear();
    for(int i = 0; i < LB_Array[readcount].size(); ++i){
        line1->append(i, LB_Array[readcount][i]);
        CurLoadBuff.append(LB_Array[readcount][i]);
    }
    c->addSeries(line1);
    ui->widgetshow->setChart(c);
    ++readcount;
    QString str;
    str.sprintf("已经加载%d次数据。",readcount);
    ui->label_times->setText(str);
}

void MainWindow::on_pushButtonRight_clicked()
{
    QChart* c = new QChart();
    QLineSeries* line1 = new QLineSeries();
    CurLoadBuff.clear();
    for(int i = 0; i < RB_Array[readcount].size(); ++i){
        line1->append(i, RB_Array[readcount][i]);
        CurLoadBuff.append(RB_Array[readcount][i]);
    }
    c->addSeries(line1);
    ui->widgetshow->setChart(c);
    ++readcount;
    QString str;
    str.sprintf("已经加载%d次数据。",readcount);
    ui->label_times->setText(str);
}

void MainWindow::on_pushButtonVF_clicked()
{
    QChart* c = new QChart();
    QLineSeries* line1 = new QLineSeries();
    CurLoadBuff.clear();
    for(int i = 0; i < VF_Array[readcount].size(); ++i){
        line1->append(i, VF_Array[readcount][i]);
        CurLoadBuff.append(VF_Array[readcount][i]);
    }
    c->addSeries(line1);
    ui->widgetshow->setChart(c);
    ++readcount;
    QString str;
    str.sprintf("已经加载%d次数据。",readcount);
    ui->label_times->setText(str);
}

//接收数据
void MainWindow::serialPort_readyRead()
{
    QByteArray rx_buf = global_port.readAll();                  //读取串口接收的数据
    QString rx_buf_tmp =QString::fromLocal8Bit(rx_buf);         //转换为中文格式
    //qDebug()<< rx_buf_tmp;                                      //控制台输出
    //uart_rx_buff.append(rx_buf_tmp);
    log += rx_buf_tmp;
    rx_buf_tmp.clear();
    rx_buf.clear();
    //显示出来
    ui->textBrowser->setText(log);
    //设置滚动条到最低
    ui->textBrowser->moveCursor(QTextCursor::End);

}

void MainWindow::on_pushButton_clear_clicked()
{
    log.clear();
    //显示出来
    ui->textBrowser->setText(log);
}

void MainWindow::on_pushButton_clearcnt_clicked()
{
    readcount = 0;
    QString str;
    str.sprintf("已经加载%d次数据。",readcount);
    ui->label_times->setText(str);
}
