#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QChartView>
#include <QLineSeries>
#include <QSerialPort>
#include <QSerialPortInfo>
using namespace QtCharts;


namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private slots:

    void on_pushButtonSend_clicked();

    void on_pushButtonUart_clicked();

    void on_pushButtonNormal_clicked();

    void on_pushButtonAPB_clicked();

    void on_pushButtonPVC_clicked();

    void on_pushButtonLeft_clicked();

    void on_pushButtonRight_clicked();

    void on_pushButtonVF_clicked();

    void on_pushButton_clear_clicked();

    void on_pushButton_clearcnt_clicked();

private:
    Ui::MainWindow *ui;

private:
    int readcount;
    QVector<QVector<double>> NormalArray;
    QVector<QVector<double>> Atrial_prematureArray;
    QVector<QVector<double>> Premature_ventricular_contractionArray;
    QVector<QVector<double>> LB_Array;
    QVector<QVector<double>> RB_Array;
    QVector<QVector<double>> VF_Array;

    //串口通讯
    QSerialPort global_port;                                // 使用串口类声明串口对象
    QByteArray uart_rx_buff;                                 // 串口接收buff
    void serialPort_readyRead(void);                        // 串口接收函数
    QVector<double> CurLoadBuff;
    //log
    QString log;

};

#endif // MAINWINDOW_H
